力扣题解(分割回文串II)

132. 分割回文串 II

给你一个字符串 s,请你将 s 分割成一些子串,使每个子串都是

回文串

。

返回符合要求的 最少分割次数

思路:

规定dpi是以i位置为最后一个元素,(0-i)的最少分割次数,此时需要从(0-i-1)中找出一个j,使得(j,i)是一个回文串,这样的话可以看成实在j位置切了一刀,然后(0-j-1)的最少切割存放在dpj-1中,则dpi=dpj-1+1(加一是在j位置又切了一刀)。

细节:由于j是默认从0位置开始计算的,则当j=0时,即(0,i)本身可以构成一个回文串,而j-1是下标-1,dp中没有下标为-1的元素,因此需要单独说明此时dpi=0(因为整体是一个回文串,因此可以一刀不切),如果想和j等于别的值保持一致,则dp需要开辟N+1个空间,第一个空间dp0=-1,dpi表示已i-1位置元素为最后一个元素切割的最小次数。

复制代码
class Solution {
public:

   

	bool judge(vector<int>&dp1, vector<int>&dp2, int left, int right)
				{

					if ((right -left+1) % 2 == 0)
						return dp2[(right +left) / 2] >= right - left+1;
					else
						return dp1[(right + left) / 2] >= right - left+1;
                }
					int minCut(string s) {
					int n = s.size();
					vector<int>dpone(n, 1);
					vector<int>dptwo(n, 0);
					for (int i = 0; i < n; i++)
					{
						int j = 1;
						while (i - j >= 0 && i + j < n && s[i - j] == s[i + j])
						{
							dpone[i] += 2;
							j++;
						}
						j = 0;
						while (i - j >= 0 && i + 1 + j < n && s[i - j] == s[i + j + 1])
						{

							dptwo[i] += 2;
							j++;
						}
					}
					vector<int>dp(n, INT_MAX);
					dp[0] = 0;
					for (int i = 1; i < n; i++)
					{
						for (int j = 0; j <= i; j++)
						{

							if (judge(dpone, dptwo, j, i))
							{
								if (j == 0)
									dp[i] = 0;
								else
									dp[i] = min(dp[j-1] + 1, dp[i]);
							}
						}
					}

					return dp.back();
				}
};
相关推荐
Yuzhiyuxia2 小时前
【AI Agent面试系列】AI Agent记忆机制知识点1
人工智能·面试·职场和发展
UIU1142 小时前
P1233 [ICPC 2001 Taejon R] 木棍加工
数据结构·c++·算法·动态规划
论文复现现场3 小时前
WRF、FEA 能用 L40S 加速吗?求解器检查、断点恢复与长期运行
java·数据库·算法·wrf·有限元分析·gpu计算·断点续算
ZhengEnCi3 小时前
用 AI 写代码为什么拼到最后还是拼人:算力瓶颈与领域专家提示词的本质差异
算法·架构
秋天的怀念_David4 小时前
第二十一夜 · 数字黑洞与西西弗斯的惩罚
java·程序人生·算法
碧海银沙音频科技研究院4 小时前
在PC电脑上用Whisper→Marian算法实现离线语音翻译功能
算法·whisper
niyongsheng5 小时前
3D 装箱算法工程化:数据结构、放置启发式与支撑规则
数据结构·算法·rust
j7~7 小时前
【穷举、深搜与回溯算法】一棵决策树讲透全排列与子集
数据结构·c++·算法·leetcode·回溯·递归
傅科摆 _ py8 小时前
DP,贪心,堆和栈,二分力扣复习
开发语言·python·算法
Shaoshing9 小时前
LeetCode100 42.接雨水
java·算法·leetcode